/***********************************************************************
 * Linotte                                                             *
 * Version release date : September 25, 2007                           *
 * Author : Mounes Ronan ronan.mounes@amstrad.eu                       *
 *                                                                     *
 *     http://langagelinotte.free.fr                                   *
 *                                                                     *
 * This code is released under the GNU GPL license, version 2 or       *
 * later, for educational and non-commercial purposes only.            *
 * If any part of the code is to be included in a commercial           *
 * software, please contact us first for a clearance at                *
 *   ronan.mounes@amstrad.eu                                           *
 *                                                                     *
 *   This notice must remain intact in all copies of this code.        *
 *   This code is distributed WITHOUT ANY WARRANTY OF ANY KIND.        *
 *   The GNU GPL license can be found at :                             *
 *           http://www.gnu.org/copyleft/gpl.html                      *
 *                                                                     *
 ***********************************************************************/

package org.linotte.frame.atelier;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Frame;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JDialog;
import javax.swing.JLabel;

import org.linotte.moteur.outils.Ressources;

/**
 * Fenetre qui s'affiche quand l'Atelier effectue l'analyse d'un livre
 *
 */

@SuppressWarnings("serial")
public class Chargement extends JDialog {

	public Chargement(Frame parent) {
		this(parent, " Je feuillette ! ");
	}

	public Chargement(Frame parent, String texte) {
		super(parent, "Chargement", false);
		Box b = Box.createHorizontalBox();
		b.add(new JLabel(" "));
		b.add(new JLabel(Ressources.getImageIcon("book.gif")));
		b.add(new JLabel(texte));
		b.add(Box.createGlue());
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		getContentPane().setBackground(Color.WHITE);
		getContentPane().add(b, "Center");
		b.setBorder(BorderFactory.createLineBorder(Color.GRAY));
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		setSize(120, 80);
		this.setLocationRelativeTo(parent);
		setResizable(false);
		setUndecorated(true);
		pack();
	}

}
