package org.linotte.greffons.impl.xyz;

import java.awt.Component;
import java.awt.Dimension;

import javax.media.j3d.BranchGroup;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.Group;
import javax.media.j3d.VirtualUniverse;

import org.linotte.greffons.externe.Composant;
import org.linotte.greffons.impl.swing.ComposantDeplacable;

import com.sun.j3d.utils.universe.SimpleUniverse;

/**
 * 
 * @author R.M
 * 
 */
public class Monde3D extends ComposantDeplacable {

	private Canvas3D canvas3d = null;
	// on crée le Bg principal
	private BranchGroup scene = null;

	static {
		// Juste pour provoquer une erreur si les librairies 3D ne sont pas présentes ou pas initialisées !
		VirtualUniverse.getProperties();
	}

	@Override
	public void initialisation() throws GreffonException {
		if (canvas3d != null) {
			super.initEvenement();
			return;
		}
		setVisible(getAttributeAsString("visible").equals("oui"));
		canvas3d = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
		// Position :
		x = getAttributeAsBigDecimal("x").intValue();
		y = getAttributeAsBigDecimal("y").intValue();
		// initEvenement();
		// Dimensions :
		int hauteur = getAttributeAsBigDecimal("hauteur").intValue();
		int largeur = getAttributeAsBigDecimal("largeur").intValue();
		canvas3d.setPreferredSize(new Dimension(largeur, hauteur));
		canvas3d.setMaximumSize(new Dimension(largeur, hauteur));
		canvas3d.setVisible(isVisible());

		scene = new BranchGroup();
		scene.setCapability(Group.ALLOW_CHILDREN_EXTEND);
		scene.setCapability(Group.ALLOW_CHILDREN_WRITE);
		scene.setCapability(BranchGroup.ALLOW_DETACH);
		SimpleUniverse simpleU = new SimpleUniverse(canvas3d);
		simpleU.getViewingPlatform().setNominalViewingTransform();
		simpleU.addBranchGraph(scene);

		super.initEvenement();
	}

	@Override
	public void ajouterComposant(Composant composant) throws GreffonException {
		if (composant instanceof Composant3D) {
			Composant3D c3d = (Composant3D) composant;
			BranchGroup bg = new BranchGroup();
			if (c3d.getComposant3D().getParent() == null)
				bg.addChild(c3d.getComposant3D());
			scene.addChild(bg);
			// scene.compile();
		}
	}

	@Override
	public Component getJComponent() throws GreffonException {
		return canvas3d;
	}

	@Override
	public boolean fireProperty(String clef) throws GreffonException {
		if (!super.fireProperty(clef)) {
		}
		return false;
	}

	@Override
	public void destruction() throws GreffonException {
		scene.detach();
		canvas3d = null;
	}

	@Override
	public boolean enregistrerPourDestruction() {
		return true;
	}
}
