package org.linotte.greffons.impl.xyz;

import javax.media.j3d.Node;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Vector3f;

public abstract class Objet3D extends Composant3D {

	protected TransformGroup transformGroup = null;

	public void initialisation(Node shape3d) throws GreffonException {

		transformGroup = new TransformGroup(new Transform3D());

		transformGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		transformGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		transformGroup.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);
		transformGroup.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
		transformGroup.addChild(shape3d);
	}

	@Override
	public boolean fireProperty(String clef) throws GreffonException {
		if (!super.fireProperty(clef)) {
		}
		return false;
	}

	@Override
	public Node getComposant3D() {
		return transformGroup;
	}

	@Slot()
	public boolean rotationx(double l) {
		Transform3D temp = new Transform3D();
		Transform3D transformFinal = new Transform3D();
		transformGroup.getTransform(transformFinal);
		temp.rotX(l);
		transformFinal.mul(temp);
		transformGroup.setTransform(transformFinal);
		return true;
	}

	@Slot()
	public boolean rotationy(double l) {
		Transform3D temp = new Transform3D();
		Transform3D transformFinal = new Transform3D();
		transformGroup.getTransform(transformFinal);
		temp.rotY(l);
		transformFinal.mul(temp);
		transformGroup.setTransform(transformFinal);
		return true;
	}

	@Slot()
	public boolean rotationz(double l) {
		Transform3D temp = new Transform3D();
		Transform3D transformFinal = new Transform3D();
		transformGroup.getTransform(transformFinal);
		temp.rotZ(l);
		transformFinal.mul(temp);
		transformGroup.setTransform(transformFinal);
		return true;
	}

	@Slot()
	public boolean translation(float x, float y, float z) {
		Transform3D temp = new Transform3D();
		Transform3D transformFinal = new Transform3D();
		transformGroup.getTransform(transformFinal);
		temp.set(new Vector3f(x, y, z));
		transformFinal.mul(temp);
		transformGroup.setTransform(transformFinal);
		return true;
	}

	@Override
	public void destruction() throws GreffonException {
		transformGroup = null;
	}
}
