package org.linotte.greffons.jsr223;

import java.io.FileNotFoundException;
import java.io.FileReader;

import javax.script.Compilable;
import javax.script.CompiledScript;
import javax.script.ScriptContext;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineFactory;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

import org.linotte.greffons.api.FabriqueGreffon;
import org.linotte.greffons.api.Greffon;
import org.linotte.moteur.xml.Version;

/***********************************************************************
 * Langage Linotte                                                     *
 * Author : Mounes Ronan ronan.mounes@amstrad.eu                       *
 *                                                                     *
 *     http://langagelinotte.free.fr                                   *
 *                                                                     *
 * This code is released under the GNU GPL license, version 3 or       *
 * later, for educational and non-commercial purposes only.            *
 * If any part of the code is to be included in a commercial           *
 * software, please contact us first for a clearance at                *
 *   ronan.mounes@amstrad.eu                                           *
 *                                                                     *
 *   This notice must remain intact in all copies of this code.        *
 *   This code is distributed WITHOUT ANY WARRANTY OF ANY KIND.        *
 *   The GNU GPL license can be found at :                             *
 *           http://www.gnu.org/copyleft/gpl.html                      *
 *                                                                     *
 ***********************************************************************/

public class Jsr223Factory implements FabriqueGreffon {

	public static final String PREFIX = "slot_";
	public static ScriptEngineManager factory;

	static {
		listScriptingEngines();
		factory = new ScriptEngineManager();
	}

	public Jsr223Factory() {
	}

	@Override
	public org.linotte.greffons.api.Greffon produire(String id, String classe) {
		String lang = "python";
		org.linotte.greffons.api.Greffon retour = null;
		ScriptEngine engine = factory.getEngineByName(lang);
		try {

			CompiledScript script = ((Compilable) engine).compile(new FileReader(classe));
			script.eval();
			retour = (Greffon) script.getEngine().getBindings(ScriptContext.ENGINE_SCOPE).get("greffon");

			//retour = engine.eval(new FileReader(classe));
			//Invocable inv = (Invocable) engine;
			//retour = inv.getInterface(org.linotte.greffons.Greffon.class);
		} catch (ScriptException e) {
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		System.out.println("Jsr223Factory a produit un " + retour);
		return (Greffon) retour;
	}

	public static void listScriptingEngines() {
		ScriptEngineManager mgr = new ScriptEngineManager();
		if (Version.isBeta()) 
			for (ScriptEngineFactory factory : mgr.getEngineFactories()) {
				System.out.println("ScriptEngineFactory Info");
				System.out.printf("\tScript Engine: %s (%s)\n", factory.getEngineName(), factory.getEngineVersion());
				System.out.printf("\tLanguage: %s (%s)\n", factory.getLanguageName(), factory.getLanguageVersion());
				for (String name : factory.getNames()) {
					System.out.printf("\tEngine Alias: %s\n", name);
				}
			}
	}

}
