package org.linotte.web.serveur;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

import org.alize.http.i.Serveur;

public abstract class AbstractServeur implements Serveur {

	public void copy(InputStream in, FileOutputStream out) throws IOException {
		byte[] buffer = new byte[1000];

		try {
			while (true) {
				synchronized (buffer) {
					int amountRead = in.read(buffer);
					if (amountRead == -1) {
						break;
					}
					out.write(buffer, 0, amountRead);
				}
			}
			out.write('\n');
		} finally {
			if (in != null) {
				in.close();
			}
			if (out != null) {
				out.close();
			}
		}
	}

}
